#ifndef __NRF24L01_H__
#define __NRF24L01_H__
#include<reg51.h>
#define uchar unsigned char
#define uint unsigned int

sbit	CE	    =P1^0;
sbit	CSN		=P1^1;
sbit	SCK	    =P1^2;
sbit 	MOSI	=P1^3;
sbit 	MISO	=P1^4;
sbit	IRQ		=P1^5;

//uchar TxBuf[20]={"1234567890abcdefghij"};
#define TX_ADR_WIDTH    5   	// 5 uints TX address width
#define RX_ADR_WIDTH    5   	// 5 uints RX address width
#define TX_PLOAD_WIDTH  32  	// 32 uints TX payload
#define RX_PLOAD_WIDTH  32  	// 32 uints TX payload
uchar  TX_ADDRESS[TX_ADR_WIDTH]= {0xE7,0xE7,0xE7,0xE7,0xE7};	//صַ
uchar  RX_ADDRESS[RX_ADR_WIDTH]= {0xE7,0xE7,0xE7,0xE7,0xE7};	//յַ
///***************************************NRF24L01Ĵָ*******************************************************
#define READ_REG        0x00  	// Ĵָ
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	// ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
#define NOP             0xFF  	// 
///*************************************SPI(nRF24L01)Ĵַ****************************************************
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define NRFRegSTATUS    0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ1ݳ
#define RX_PW_P2        0x13  // Ƶ2ݳ
#define RX_PW_P3        0x14  // Ƶ3ݳ
#define RX_PW_P4        0x15  // Ƶ4ݳ
#define RX_PW_P5        0x16  // Ƶ5ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
///*****************************Ӻ*********************************************************
uchar NRF24SPI_Send_Byte(uchar dat);
uchar SPI_WR_Reg(uchar reg, uchar value);
uchar SPI_Read_Buf(uchar reg, uchar *pBuf, uchar Len);
uchar SPI_Write_Buf(uchar reg, uchar *pBuf, uchar Len);
uchar nRF24L01_RxPacket(unsigned char* rx_buf);
void nRF24L01_TxPacket(unsigned char * tx_buf);
uchar SPI_RD_Reg(uchar reg);
void init_NRF24L01(void);
void TX_Mode(void);
void RX_Mode(void);
void NRF_Send(void);
uchar NRF24L01_Check(void);
///*************************************************************************************
uchar NRF24SPI_Send_Byte(uchar dat)
{
  uchar i;
   for (i = 0; i < 8; i++) // output 8-bit
   {
      //1λ
      if (dat & 0x80)         // output 'uchar', MSB to MOSI
      {
         MOSI = 1;
      }
      else
      {
         MOSI = 0;
      }

      dat <<= 1;           // shift next bit into MSB..
      
      //ȡ1λ
      SCK = 1;                      // Set SCK high..

      if (MISO)
      {
         dat |= 1;
      }             // capture current MISO bit
      else
      {
         dat &= 0xFE;
      }
      SCK = 0;                    // ..then set SCK low again
   }
   
   return(dat);                  // return read uchar
}

void Delay_n10us(uint n)	   //ʱn10us
{
   for(;n>0;n--)
   {
   	 unsigned char a,b;
     for(b=1;b>0;b--)
         for(a=2;a>0;a--);
   }
}
///****************************************************************************************
///*NRF24L01Ƿ
///***************************************************************************************/
uchar NRF24L01_Check(void)
{
	uchar bu[5]={0XA5,0XA5,0XA5,0XA5,0XA5};
	uchar bu1[5];
	uchar i;   	 
	SPI_Write_Buf(WRITE_REG+TX_ADDR,bu,5);//д5ֽڵĵַ.	
	SPI_Read_Buf(TX_ADDR,bu1,5);              //дĵַ  	
	for(i=0;i<5;i++)if(bu1[i]!=0XA5)break;					   
	if(i!=5)return 1;                               //NRF24L01λ	
	return 0;		                                //NRF24L01λ
}	 	 
///****************************************************************************************
///*NRF24L01ʼ
///***************************************************************************************/
void init_NRF24L01(void)
{
   uchar buf[5]={0};
   Delay_n10us(10);
   CE = 0;    // chip enable
   CSN= 0;    // Spi disable 
  
  SPI_Read_Buf(TX_ADDR, buf, TX_ADR_WIDTH);//debug ԭıصַλֵǣ0xE7 0xE7 0xE7 0xE7 0xE7
  
//	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
//	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ

//	
//	SPI_WR_Reg(WRITE_REG + EN_AA, 0x01);      //  Ƶ0Զ	ACKӦ	
//	SPI_WR_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
//	SPI_WR_Reg(WRITE_REG + SETUP_RETR, 0x1a); // Զطʱʹ500us + 86us, 10 retrans...
//	SPI_WR_Reg(WRITE_REG + RF_CH, 22);        //   ŵΪ2.4GHZշһ
//	SPI_WR_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
//	SPI_WR_Reg(WRITE_REG + RF_SETUP, 0x07);   		//÷Ϊ1MHZ书Ϊֵ0dB
//  
//  SPI_RD_Reg(WRITE_REG + EN_AA);
//  SPI_RD_Reg(WRITE_REG + EN_RXADDR);
//  SPI_RD_Reg(WRITE_REG + RF_CH);
//  SPI_RD_Reg(WRITE_REG + RX_PW_P0);
//  SPI_RD_Reg(WRITE_REG + RF_SETUP);
}
///****************************************************************************************************
///*uchar SPI_Read(uchar reg)
///*ܣNRF24L01SPIʱ
///****************************************************************************************************/
uchar SPI_RD_Reg(uchar reg)
{
	uchar reg_val;
	
	CSN = 0;                // CSN low, initialize SPI communication...
	NRF24SPI_Send_Byte(reg);            // Select register to read from..
	reg_val = NRF24SPI_Send_Byte(0);    // ..then read registervalue
	CSN = 1;                // CSN high, terminate SPI communication
	
	return(reg_val);        // return register value
}
//****************************************************************************************************/
//*ܣNRF24L01дĴ
//****************************************************************************************************/
uchar SPI_WR_Reg(uchar reg, uchar value)
{
	uchar status;
	
	CSN = 0;                   // CSN low, init SPI transaction
	status = NRF24SPI_Send_Byte(reg);// select register
	NRF24SPI_Send_Byte(value);             // ..and write value to it..
	CSN = 1;                   // CSN high again
	
	return(status);            // return nRF24L01 status uchar
}
///****************************************************************************************************/
//*uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar Len)
//*: ڶݣregΪĴַpBufΪݵַucharsݵĸ
//****************************************************************************************************/
uchar SPI_Read_Buf(uchar reg, uchar *pBuf, uchar Len)
{
	uint status,i;
	
	CSN = 0;                    		// Set CSN low, init SPI tranaction
	status = NRF24SPI_Send_Byte(reg);       		// Select register to write to and read status uchar
	
  for(i=0;i<Len;i++)
  {
     pBuf[i] = NRF24SPI_Send_Byte(0);
  }
	
	CSN = 1;                           
	
	return(status);                    // return nRF24L01 status uchar
}
//*********************************************************************************************************
//*uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar Len)
//*: дݣΪĴַpBufΪдݵַucharsдݵĸ
//*********************************************************************************************************/
uchar SPI_Write_Buf(uchar reg, uchar *pBuf, uchar Len)
{
	uint status,i;
	
	CSN = 0;            //SPIʹ       
	status = NRF24SPI_Send_Byte(reg);   
	for(i=0; i<Len; i++) //
	{
	   NRF24SPI_Send_Byte(*pBuf);
		 pBuf ++;
	}
	CSN = 1;           //رSPI
	return(status);    // 
}

//****************************************************************************************************/
//*void SetRX_Mode(void)
//*ܣݽ 
//****************************************************************************************************/
void RX_Mode(void)
{
    uchar buf[5]={0};
	CE = 0;
	
	SPI_Read_Buf(TX_ADDR, buf, TX_ADR_WIDTH);//debug ԭıصַλֵǣ0xE7 0xE7 0xE7 0xE7 0xE7
	//SPI_WR_Reg(WRITE_REG + CONFIG, 0x03);//SPI_WR_Reg(WRITE_REG + CONFIG, 0x0f); // IRQշжӦ16λCRC	
	
	//SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	
	SPI_WR_Reg(WRITE_REG + EN_AA, 0);//0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_WR_Reg(WRITE_REG + EN_RXADDR,0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_WR_Reg(WRITE_REG + SETUP_RETR,0x1a); // Զطʱʹ500us + 86us, 10 retrans...
	SPI_WR_Reg(WRITE_REG + RF_CH, 40);        //   ŵΪ2.4GHZշһ
	SPI_WR_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_WR_Reg(WRITE_REG + RF_SETUP, 0x0F);   		//÷Ϊ2MHZ书Ϊֵ0dB
	
	SPI_WR_Reg(WRITE_REG + CONFIG, 0x0F);//0x0F);	
	CE = 1; 
	Delay_n10us(20); //200us
}
//******************************************************************************************************/
//*unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
//*ܣݶȡrx_bufջ
//******************************************************************************************************/
uchar nRF24L01_RxPacket(unsigned char* rx_buf)
{
    uchar flag=0;
    uchar status;
 	
	status=SPI_RD_Reg(NRFRegSTATUS);	// ȡ״̬Ĵжݽ״
	
	if(status & 0x40)				// жǷյ
	{
	   CE = 0; 			//SPIʹ
		 SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
		 flag =1;			//ȡɱ־
	}
	SPI_WR_Reg(WRITE_REG+NRFRegSTATUS, status);   //յݺRX_DR,TX_DS,MAX_RTøΪ1ͨд1жϱ־
	return flag;
}
void TX_Mode(void)
{
    CE = 0;
	//SPI_WR_Reg(WRITE_REG + CONFIG, 0x02);   //0x0E		 // IRQշжӦ16λCRC
	
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	
	SPI_WR_Reg(WRITE_REG + EN_AA, 0);//0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_WR_Reg(WRITE_REG + EN_RXADDR,0);// 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_WR_Reg(WRITE_REG + SETUP_RETR, 0);//0x1a); // Զطʱʹ500us + 86us, 10 retrans...
	SPI_WR_Reg(WRITE_REG + RF_CH, 40);        //   ŵΪ2.4GHZշһ
	SPI_WR_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_WR_Reg(WRITE_REG + RF_SETUP, 0x0F);   		//÷Ϊ2MHZ书Ϊֵ0dB

	SPI_WR_Reg(WRITE_REG + CONFIG, 0x0E);
    CE = 1;
}
//***********************************************************************************************************
//*void nRF24L01_TxPacket(unsigned char * tx_buf)
//*ܣ tx_buf
//**********************************************************************************************************/
void nRF24L01_TxPacket(unsigned char * tx_buf)
{
	CE = 0;			//StandBy Iģʽ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ	
//	SPI_WR_Reg(WRITE_REG + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC
	CE = 1;		 //øCEݷ
}


///************************************************************************************************
//void NRF_Send(void)
//{
//  //static uint counter=0;
//  static uchar flag=0;  
//   
//   //TX_Mode();
//   
//   //IntervalTimems(100);
//   if(flag==0)
//   {
//      flag=1;
//      //memcpy(TxBuf, "1234567890abcdefghij", 20);
//      nRF24L01_TxPacket(TxBuf);
//   }
//   else
//   {
//      flag=0;
//      //memcpy(TxBuf, "abcdefghij1234567890", 20);
//      nRF24L01_TxPacket(TxBuf);
//   }
//   
//}





#endif   /*__NRF24L01_H__ */
